millecabosses/urls.py
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static
from django.conf import settings
from django.contrib import admin

from application import views


urlpatterns = patterns(
    "",
    url(r"^admin/", include(admin.site.urls)),
    url(r"^$", views.index, name="index"),
    url(
        r"^(?P<page_id>\d+)-(?P<page_alias>\w+)/$",
        views.page_details,
        name="page_details",
    ),
    url(
        r"^produit/(?P<product_id>\d+)-(?P<product_name>\w+)/$",
        views.product_details,
        name="product_details",
    ),
) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

application/models.py
# coding: utf-8

import os

from django.db import models
from django_thumbs.db import models as models_thumb


LOCATION_CHOICES = ((1, "header"), (2, "aside"), (3, "footer"))


class Media(models.Model):
    file = models.FileField()

    def type(self):
        _, ext = os.path.splitext(self.file.name)
        ext = ext[1:].lower()
        if ext == "pdf":
            return "PDF"
        elif ext in ("jpg", "jpeg", "png", "gif"):
            return "Image"
        else:
            return "Autre"

    def filename(self):
        return os.path.basename(os.path.splitext(self.file.name)[0])

    def url(self):
        return self.file.url

    def __unicode__(self):
        return self.filename()


class Page(models.Model):
    title = models.CharField(max_length=250)
    alias = models.CharField(max_length=50)
    pub_date = models.DateTimeField("publication date")
    layout = models.CharField(max_length=50)
    order = models.PositiveSmallIntegerField(default=1)
    location = models.PositiveSmallIntegerField(default=1, choices=LOCATION_CHOICES)
    is_published = models.BooleanField(default=True)
    is_product_page = models.BooleanField(default=False)

    class Meta:
        ordering = ["order"]

    def iter_blocks(self):
        blocks = self.textblock_set.order_by("order").all()
        current_block = 0

        for char in self.layout:
            try:
                nb_block = int(char)
            except ValueError:
                continue

            next_block = current_block + nb_block
            yield blocks[current_block:next_block]
            current_block = next_block

    def __unicode__(self):
        return self.title


class TextBlock(models.Model):
    content = models.TextField(default="")
    is_important = models.BooleanField(default=False)
    is_centered = models.BooleanField(default=False)
    illustration_url = models.CharField(max_length=250, blank=True)
    order = models.PositiveSmallIntegerField(default=1)
    page = models.ForeignKey(Page)

    class Meta:
        ordering = ["order"]
        verbose_name = "Bloc de texte"

    def __unicode__(self):
        return self.content[:100]


class Link(models.Model):
    title = models.CharField(max_length=250)
    url = models.CharField(max_length=250)

    class Meta:
        ordering = ["title"]
        verbose_name = "Lien"

    def __unicode__(self):
        return self.title


class ProductCategory(models.Model):
    name = models.CharField(max_length=250)

    class Meta:
        ordering = ["name"]
        verbose_name = "Catégorie de produits"
        verbose_name_plural = "Catégories de produits"

    def __unicode__(self):
        return self.name


class Product(models.Model):
    name = models.CharField(max_length=250)
    description = models.TextField(default="")
    image = models_thumb.ImageWithThumbsField(
        default="", blank=True, sizes=((150, 150),)
    )
    category = models.ForeignKey(ProductCategory)
    attachments = models.ManyToManyField(Media, blank=True)

    def all_images(self):
        if self.image:
            yield self.image

        for media in self.attachments.all():
            if media.type() == "Image":
                yield media

    def other_images(self):
        for media in self.attachments.all():
            if media.type() == "Image":
                yield media

    class Meta:
        ordering = ["name"]
        verbose_name = "Produit"

    def __unicode__(self):
        return self.name


class Ingredient(models.Model):
    name = models.CharField(max_length=250)
    origin = models.CharField(max_length=250, blank=True)
    url = models.CharField(max_length=250, blank=True)
    product = models.ForeignKey(Product)

    class Meta:
        ordering = ["name"]
        verbose_name = "Ingrédient"

    def __unicode__(self):
        return self.name

application/views.py
# coding: utf-8
from datetime import datetime

from django.shortcuts import render, get_object_or_404
from django.http import Http404

from application.models import Page, Link, ProductCategory, Product


CONTACT = {
    "mail": "chocolaterie1000cabosses@gmail.com",
    "tel": "06 82 77 21 67",
    "address": "7 Grande rue<br />23120 Vallière",
    "facebook": "https://www.facebook.com/chocolaterie1000cabosses",
    "osm": '<iframe src="https://www.openstreetmap.org/export/embed.html?bbox=2.027202844619751%2C45.90343342047435%2C2.0451200008392334%2C45.910055254506595&amp;layer=mapnik&amp;marker=45.9067444362303%2C2.036161422729492"></iframe>',
}


def get_current_season():
    current_date = datetime.now()

    start_easter = datetime(current_date.year, 3, 22)
    end_easter = datetime(current_date.year, 4, 25)
    if start_easter <= current_date <= end_easter:
        return "easter"

    halloween = datetime(current_date.year, 10, 31)
    if halloween.date() == current_date.date():
        return "halloween"

    start_christmas = datetime(current_date.year, 12, 1)
    end_christmas = datetime(current_date.year, 12, 31)
    if start_christmas <= current_date <= end_christmas:
        return "christmas"


def get_site_infos(current_page, show_list_products=False, current_product=None):
    return {
        "current_page": current_page,
        "pages_header": Page.objects.filter(location=1, is_published=True),
        "pages_aside": Page.objects.filter(location=2, is_published=True),
        "pages_footer": Page.objects.filter(location=3, is_published=True),
        "product_categories": ProductCategory.objects.all(),
        "list_products_active": show_list_products,
        "links": Link.objects.all(),
        "contact": CONTACT,
        "current_product": current_product,
        "current_season": get_current_season(),
    }


def index(request):
    return page_details(request)


def page_details(request, page_id=None, page_alias=None):
    if page_id is None:
        page = Page.objects.first()
    else:
        page = get_object_or_404(Page, pk=page_id)

    show_list_products = page.is_product_page

    return render(
        request,
        "application/page_details.html",
        get_site_infos(page, show_list_products),
    )


def product_details(request, product_id, product_name=None):
    product = get_object_or_404(Product, pk=product_id)

    # That's a dirty way to set active "Mes produits" item in the header
    pages = Page.objects.filter(is_product_page=True, is_published=True)
    if not pages:
        raise Http404("There is no product page.")

    return render(
        request,
        "application/product_details.html",
        get_site_infos(pages[0], True, product),
    )

application/templates/application/__base.html
{% load staticfiles %}
<!DOCTYPE html>
<html lang="fr">
    <head>
        {% block meta %}
            <meta charset="utf-8">
            <meta name="viewport" content="initial-scale=1.0" />
            <link rel="shortcut icon" id="favicon" type="image/x-icon" sizes="16x16 64x64" href="/favicon.ico" />
        {% endblock %}
        <title>{% block title %}Chocolaterie 1000 Cabosses{% endblock %}</title>
        {% block stylesheets %}
            <link rel="stylesheet" type="text/css" href="{% static 'application/css/base.css' %}">
        {% endblock %}
        {% block javascript %}{% endblock %}
        {% block extra_head %}{% endblock %}
    </head>
    <body>
        <header>
            {% include "application/_header.html" %}
        </header>

        <div id="main" class="main" role="main">
            {% block content %}
            {% endblock %}
        </div>

        <footer>
            {% include "application/_footer.html" %}
        </footer>

        <div id="up-to-the-sky" class="intersecting">
            <button>Retourner en haut</button>
        </div>
        <script type="text/javascript" src="{% static 'application/js/up-to-the-sky.js' %}"></script>
    </body>
</html>

application/templates/application/_footer.html
{% load staticfiles simplify clean_url %}

<div class="container">
    <div class="top">
        <a class="box" href="{% url 'index' %}" id="logo">
            <img src="{% static 'application/img/logo256-inverse.png' %}" alt="" />
        </a>

        {% if links %}
        <div class="box" id="liens">
            <div class="box-title">Liens et partenaires</div>
            <ul>
                {% for link in links %}
                <li class="item"><a target="_blank" href="{{ link.url|clean_url }}">{{ link.title }}</a></li>
                {% endfor %}
            </ul>
        </div>
        {% endif %}

        <div class="box" id="follow">
            <div class="box-title">Contactez-moi</div>
            <ul>
                <li class="item item-mail"><a href="mailto:{{ contact.mail }}">{{ contact.mail }}</a></li>
                <li class="item item-tel">{{ contact.tel }}</li>
                <li class="item item-address">{{ contact.address|safe }}</li>
                <li class="item item-fb"><a target="_blank" href="{{ contact.facebook }}">Retrouvez-moi sur Facebook</a></li>
            </ul>
        </div>

    </div>

    <div id="osm">
        {{ contact.osm|safe }}
    </div>

    <ul class="bottom">
        <li class="item"><a href="{% url 'index' %}">Accueil</a></li>
        {% for page in pages_footer %}
        <li class="item">
            <a href="{% url 'page_details' page.id page.alias|simplify %}">{{ page.alias }}</a>
        </li>
        {% endfor %}
    </ul>
</div>

application/templates/application/_header.html
{% load staticfiles simplify %}

<div class="container">
    <div class="logo">
      <a href="{% url 'index' %}">
        <img src="{% static 'application/img/logo-header.png' %}" alt="" />
      </a>
    </div>
    <nav>
        <ul><!--
            {% for page in pages_header %}
            --><li class="item item-{{ page.alias|simplify }} {% if current_page.id == page.id %}current{% endif %}">
                <a href="{% url 'page_details' page.id page.alias|simplify %}">{{ page.alias }}</a>
            </li><!--
            {% endfor %}
        --></ul>
    </nav>
</div>

application/templates/application/_product.html
{% load staticfiles simplify %}

<li class="product {% if product == current_product %}current{% endif %}">
    <a href="{% url 'product_details' product.id product.name|simplify %}">
        <div class="product-image">
            {% if product.image %}
                <img alt="" src="{{ product.image.url_150x150 }}" />
            {% elif current_season == "easter" %}
                <img alt="" src="{% static 'application/img/missing_image_easter.png' %}" />
            {% elif current_season == "halloween" %}
                <img alt="" src="{% static 'application/img/missing_image_halloween.png' %}" />
            {% elif current_season == "christmas" %}
                <img alt="" src="{% static 'application/img/missing_image_christmas.png' %}" />
            {% else %}
                <img alt="" src="{% static 'application/img/missing_image.png' %}" />
            {% endif %}
        </div>
        <span class="product-name">
            {{ product }}
        </span>
    </a>
</li>

application/templates/application/_products_category.html
{% load simplify %}

{% if category.product_set.all|length > 0 %}
    <div class="product-category">
        <div class="product-category-name">
            Les autres « {{ category }} »
            (<a href="{% url 'page_details' current_page.id current_page.alias|simplify %}">voir tous mes produits</a>)
        </div>

        <ul class="products">
            {% for product in category.product_set.all %}
                {% include "application/_product.html" %}
            {% endfor %}
        </ul>
    </div>
{% endif %}

application/templates/application/_products_list.html
{% for category in product_categories %}
    {% if category.product_set.all|length > 0 %}
        <h2>{{ category }}</h2>
        <ul class="products">
            {% for product in category.product_set.all %}
                {% include "application/_product.html" %}
            {% endfor %}
        </ul>
    {% endif %}
{% endfor %}

application/templates/application/page_details.html
{% extends "application/__base.html" %}

{% load markdown_filter %}

{% block title %}{{ current_page.title }} – {{ block.super }}{% endblock %}

{% block content %}
    <section class="content">
        <div class="container">
            <h1>{{ current_page.title }}</h1>

            {% if list_products_active %}
                {% include "application/_products_list.html" %}
            {% else %}
                {% for blocks in current_page.iter_blocks %}
                    <div class="row">
                        {% for block_ in blocks %}
                            <div class="block {% if block_.is_centered %}centered{% endif %} {% if block_.is_important %}important{% endif %} {% if block_.illustration_url %}illustrated{% endif %}"
                                 {% if block_.illustration_url %}style="background-image: url('{{ block_.illustration_url }}');"{% endif %}
                            >
                                <div class="text">{{ block_.content|markdownify|safe }}</div>
                            </div>
                        {% endfor %}
                    </div>
                {% endfor %}
            {% endif %}
        </div>
    </section>
{% endblock %}

application/templates/application/product_details.html
{% extends "application/__base.html" %}

{% load markdown_filter clean_url %}

{% block title %}{{ current_product }} – {{ block.super }}{% endblock %}

{% block content %}
    <section class="content product" id="product">
        {% if current_product.image %}
            <div class="photos-slideshow" style="background-image: url({{ current_product.image.url }});">
                <div class="container">
                    {% for image in current_product.all_images %}
                        <img alt="" src="{{ image.url }}" />
                    {% endfor %}
                </div>
            </div>
        {% endif %}

        <div class="container">
            <h1>{{ current_product }}</h1>

            <div class="row">
                <div class="block product-info">
                    <div class="text">
                        {{ current_product.description|markdownify|safe }}

                        {% if current_product.ingredient_set.all|length > 0 %}
                            <h2>Ingrédients</h2>
                            <ul>
                                {% for ingredient in current_product.ingredient_set.all %}
                                    {% if ingredient.origin and ingredient.url %}
                                        <li>{{ ingredient }} (<a href="{{ ingredient.url|clean_url }}" target="_blank">{{ ingredient.origin }}</a>)</li>
                                    {% elif ingredient.origin %}
                                        <li>{{ ingredient }} ({{ ingredient.origin }})</li>
                                    {% else %}
                                        <li>{{ ingredient }}</li>
                                    {% endif %}
                                {% endfor %}
                            </ul>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>

        <div class="container">
            {% include "application/_products_category.html" with category=current_product.category %}
        </div>
    </section>
{% endblock %}